//+------------------------------------------------------------------+
//|                                                     Vendetta.mq4 |
//|                                                               TV |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "TV"
#property link      ""

extern double Lots=0.1;
extern double TakeProfit=300;
extern double TrailingStop=150;
double current,direction;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
int Crossed (double line1 ,double line2){
   static int last_direction =0;
   static int current_direction =0;
   if(line1>line2)current_direction=1;
   if(line1<line2)current_direction=2;
   if (current_direction!=last_direction){
      last_direction=current_direction;
      return(last_direction);
   }
   else
   {
      return(0);
   }
      
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){
   int cnt,ticket,total;
   double shortEMA,longEMA;
   if (Bars<100){
      Print("bars less than 100");
      return (0);
   }
   if(TakeProfit<3){
      Print("Take profit less than 10");
      return (0);
   }
   shortEMA=iMA(NULL,0,24,0,MODE_EMA,PRICE_CLOSE, 0);
   longEMA=iMA(NULL,0,50,0,MODE_EMA,PRICE_CLOSE, 0);
   int isCrossed=Crossed(shortEMA,longEMA);
   total=OrdersTotal();
   if(total<1){
      if(isCrossed==1){
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"Vendetta",1987610,0,Green);
         if(ticket>0){
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("Buy order opened");
         }
         else Print ("Error opening buy order",GetLastError());
         return(0);
      }
      if(isCrossed==2){
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Ask,3,0,Bid-TakeProfit*Point,"Vendetta",1987610,0,Red);
         if(ticket>0){
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("Sell order opened");
         }
         else Print ("Error opening sell order",GetLastError());
         return(0);
      }
      return(0);
   }
   for(cnt=0;cnt<total;cnt++){
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if( (OrderType()<=OP_SELL) && (OrderSymbol()==Symbol()) ){
         if(OrderType()==OP_BUY){
            if(isCrossed==2){
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
               return(0);
            }
            if(TrailingStop>0){
               if(Bid-OrderOpenPrice()>Point*TrailingStop){
                  if(OrderStopLoss()<Bid-Point*TrailingStop){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                  }
               }
            }
         }
         else{
            if(isCrossed==1){
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
               return(0);
            }
            if(TrailingStop>0){
               if( (OrderOpenPrice()-Ask) > (Point*TrailingStop) ){
                  if( (OrderStopLoss() > (Ask+Point*TrailingStop)) || (OrderStopLoss()==0)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
   
   return(0);
}

